local Widgets = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Widgets")
local Loc = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Localisation")
local _ARTG = _Avyr_Raid_Tools_ADDON_Globals
local wipe, insert, remove = table.wipe, table.insert, table.remove
local Padding, BorderSize = Widgets.Padding, Widgets.BorderSize

local Editor = _ARTG.Editor

local Window

local EditorPopupWindow

_ARTG.SV.RegisterSVCallback(function(varName,varValue)
	if varName == "ALL" or varName == "NE_PosX" or varName == "NE_PosY" or varName == "NE_Scale" or varName == "NE_FullScreen" then 
		_ARTG.Editor:UpdatePosition()
	end 

	if varName == "CurrentNote" then 
		_ARTG.Editor:Refresh()
	end 
end,"ALL","NE_PosX","NE_PosY","NE_Scale","NE_FullScreen","CurrentNote")

local col1,col2,col3 = 250,500,150

local ExpandedTabSelectDataSource = {}
local SelectedNote = {}
Editor.Call = function(self,Force)
	if Window and not Window.Released and Force ~= "Open" then
		Window:Release()
		Window = nil;
		_ARTG.OpenMenu = nil
	elseif not Window and Force ~= "Close" then 
		_ARTG.OptionsMenu:Call("Close");
		_ARTG.OptionsMenu:QuickCall("Close");

		Window = Widgets:CreateWindow(UIParent, Loc:Translation("ENCOUNTER_NOTES_EDITOR"))
		Window.OnCloseFunc = function() Window = nil end
		Window:Size(col1 + col2 + col3 + 2*Widgets.BorderSize + 4*Widgets.Padding, 700)
		Window:MakeMovable(true)
		Window.OnMove = function(self)
			local _, _, _, x, y = self:GetPoint(1)
			_ARTG.SV.SaveVariable("NE_PosX", x*Window:GetEffectiveScale(), true)
			_ARTG.SV.SaveVariable("NE_PosY", y*Window:GetEffectiveScale())
		end
		local EntryBoxHeight = 80 + 5*Widgets.Padding + 2*Widgets.BorderSize

		-----------------------Col 1
		Window.LoadedNoteLB = Widgets:FetchFontString(Window)
		Window.LoadedNoteLB:SetText(Loc:Translation("LOADED_NOTE"))
		Window.LoadedNoteLB:SetWidth(col1)
		Window.LoadedNoteLB:SetJustifyH("LEFT")
		Window.LoadedNoteLB:SetFontSizeOnly(15)
		Widgets:SetThemedColor(Window.LoadedNoteLB,"Highlight")
		Window.LoadedNoteLB:SetPoint("TOPLEFT", Window.Header, "BOTTOMLEFT", 0, -Widgets.Padding)

		Window.LoadedNoteButton = Widgets:CreateFrame(Window)
		Window.LoadedNoteButton:Size(col1, 20)
		Window.LoadedNoteButton:SetThemedBackdrop()
		Window.LoadedNoteButton:SetText({
			{Text = Loc:Translation("NO_NOTE_LOADED"), FontSize = 15, r = "Normal", HAlign = "LEFT", VAlign = "TOP"},
			{Text = "", FontSize = 11, r = "Normal", HAlign = "LEFT", VAlign = "TOP"}
		})
		Window.LoadedNoteButton:SetPoint("TOPLEFT",Window.LoadedNoteLB,"BOTTOMLEFT",0,-Widgets.Padding)
		
		Window.SaveLoaded = Widgets:CreateButton(Window)
		Window.SaveLoaded:Size((col1 - Widgets.Padding)/2,20)
		Window.SaveLoaded:SetText(Loc:Translation("SAVE"),nil,"Highlight")
		Window.SaveLoaded:SetPoint("TOPLEFT",Window.LoadedNoteButton,"BOTTOMLEFT",0,-Widgets.Padding)
		Window.SaveLoaded.OnClick = function()
			Editor:NoteInfoEdit(_ARTG.SV.GetVariable("CurrentNote").Name,_ARTG.SV.GetVariable("CurrentNote").Description,
			_ARTG.SV.GetVariable("CurrentNote").Expansion,_ARTG.SV.GetVariable("CurrentNote").Raid,_ARTG.SV.GetVariable("CurrentNote").Boss,
			function(Name,Description,Expansion,Raid,Boss)
				local DataClone = {}
				if _ARTG.SV.GetVariable("CurrentNote").Data then 
					for i,v in ipairs(_ARTG.SV.GetVariable("CurrentNote").Data) do 
						insert(DataClone,{v[1],v[2]})
					end 
				else 
					DataClone = nil
				end 
				Editor:EditNote("New",Name,Description,DataClone,Expansion,Raid,Boss)
			end)
		end

		Window.ClearLoaded = Widgets:CreateButton(Window)
		Window.ClearLoaded:Size((col1 - Widgets.Padding)/2,20)
		Window.ClearLoaded:SetText(Loc:Translation("CLEAR"),nil,"Highlight")
		Window.ClearLoaded:SetPoint("TOPLEFT",Window.SaveLoaded,"TOPRIGHT",Widgets.Padding,0)
		Window.ClearLoaded.OnClick = function()
			_ARTG.SV.SaveVariable("CurrentNote",{})
		end 


		Window.NoteListHeaderLB = Widgets:FetchFontString(Window)
		Window.NoteListHeaderLB:SetText(Loc:Translation("SAVED_NOTES"))
		Window.NoteListHeaderLB:SetWidth(col1)
		Window.NoteListHeaderLB:SetJustifyH("LEFT")
		Window.NoteListHeaderLB:SetFontSizeOnly(15)
		Widgets:SetThemedColor(Window.NoteListHeaderLB,"Highlight")
		Window.NoteListHeaderLB:SetPoint("TOPLEFT", Window.SaveLoaded, "BOTTOMLEFT", 0, -Widgets.Padding)

		Window.TabDisplay = Widgets:CreateSectionSelect(Window)
		Window.TabDisplay:Size(col1, Window:GetHeight() - Window.Header:GetHeight() - 2 * Widgets.BorderSize - 8 * Widgets.Padding - 40 - Window.NoteListHeaderLB:GetHeight() - Window.LoadedNoteButton:GetHeight() - Window.LoadedNoteLB:GetHeight())
		Window.TabDisplay:SetPoint("TOPLEFT", Window.NoteListHeaderLB, "BOTTOMLEFT", 0, -Widgets.Padding)
		Window.TabDisplay.ExpandedCategories = ExpandedTabSelectDataSource
		Window.TabDisplay.OnSelect = function(Name,Key)
			local Expansion, Raid, Boss, Index = strsplit("\023",Key)
			if Expansion ~= "Deprecated" and Expansion ~= "Other" then 
				Expansion = tonumber(Expansion)
				if Raid ~= "Other" then 
					Raid = tonumber(Raid)
					if Boss ~= "Other" then 
						Boss = tonumber(Boss)
					end
				else 
					Boss = nil
				end 
			else 
				Raid = nil
				Boss = nil
			end
			Index = tonumber(Index)
			if Expansion and AvyrRaidTools_DB.Notes[Expansion] then 
				SelectedNote.Key = Key
				SelectedNote.Expansion = Expansion
				SelectedNote.Raid = Raid
				SelectedNote.Boss = Boss
				SelectedNote.Index = Index
			end 
			Editor:LoadNote()
		end

		Window.NewBtn = Widgets:CreateButton(Window)
		Window.NewBtn:Size((col1 - Widgets.Padding)/2,20)
		Window.NewBtn:SetText(Loc:Translation("NEW"),nil,"Highlight")
		Window.NewBtn:SetPoint("TOPLEFT",Window.TabDisplay,"BOTTOMLEFT",0,-Widgets.Padding)
		Window.NewBtn.OnClick = function()
			Editor:NoteInfoEdit(Loc:Translation("NEW_NOTE"),"",nil,nil,nil,function(Name,Description,Expansion,Raid,Boss)
				Editor:EditNote("New",Name,Description,nil,Expansion,Raid,Boss)
			end)
		end

		Window.ImportBtn = Widgets:CreateButton(Window)
		Window.ImportBtn:Size((col1 - Widgets.Padding)/2,20)
		Window.ImportBtn:SetText(Loc:Translation("IMPORT"),nil,"Highlight")
		Window.ImportBtn:SetPoint("TOPLEFT",Window.NewBtn,"TOPRIGHT",Widgets.Padding,0)
		Window.ImportBtn.OnClick = function()
			_ARTG.Coms.ImportNote()
		end 
		_ARTG.OpenMenu = "Editor"
	end 
	if _ARTG.OpenMenu == "Editor" then 
		Editor:UpdatePosition()
		Editor:Refresh(true)
	end 
end 

Editor.EditNote = function(self,Action,...)
	if Action == "New" then 
		local Name,Description,Data,Expansion,Raid,Boss = ...

		AvyrRaidTools_DB.Notes[Expansion or "Other"] = AvyrRaidTools_DB.Notes[Expansion or "Other"] or {}
		AvyrRaidTools_DB.Notes[Expansion or "Other"][Raid or "Other"] = AvyrRaidTools_DB.Notes[Expansion or "Other"][Raid or "Other"] or {}
		AvyrRaidTools_DB.Notes[Expansion or "Other"][Raid or "Other"][Boss or "Other"] = AvyrRaidTools_DB.Notes[Expansion or "Other"][Raid or "Other"][Boss or "Other"] or {}
		insert(AvyrRaidTools_DB.Notes[Expansion or "Other"][Raid or "Other"][Boss or "Other"],{
			 ["Name"] = Name or "",
			 ["Description"] = Description or "",
			 ["Data"] = Data,
		})
		Editor:Refresh(true,getn(AvyrRaidTools_DB.Notes[Expansion or "Other"][Raid or "Other"][Boss or "Other"]),Expansion or "Other",Raid or "Other",Boss or "Other")
	elseif Action == "Delete" then 
		local Expansion,Raid,Boss,Index = ...
		local NoteDirectory = _ARTG.SV.CheckNoteExists(Expansion,Raid,Boss,Index,true) 
		if NoteDirectory then 
			table.remove(NoteDirectory,Index)
			Editor:Refresh(true,true)
		end 
	elseif Action == "Duplicate" then 
		local Expansion,Raid,Boss,Index = ...
		local Note = _ARTG.SV.CheckNoteExists(Expansion,Raid,Boss,Index) 
		if type(Note.Data) == "table" then 
			local DataClone = _ARTG.DataFuncs.cloneTable(Note.Data)
			Editor:EditNote("New",Note.Name,Note.Description,DataClone,Expansion,Raid,Boss)
		else 
			Editor:EditNote("New",Note.Name,Note.Description,nil,Expansion,Raid,Boss)
		end         
	end
end 

Editor.UpdatePosition = function(self)
	if Window and not Window.Released then
		Window:SetScale(_ARTG.SV.GetVariable("NE_Scale") or Window:GetScale())
		local Scale = Window:GetEffectiveScale()
		Window:SetPoint("CENTER",(_ARTG.SV.GetVariable("NE_PosX") or 0)/Scale,(_ARTG.SV.GetVariable("NE_PosY") or 0)/Scale)
	end
end

Editor.Refresh = function(self,RefreshList,...)
	if ... then 
		if type(...) == "boolean" then 
			wipe(SelectedNote)
		else
			local Index,Expansion,Raid,Boss = ...
			if AvyrRaidTools_DB.Notes[Expansion] and AvyrRaidTools_DB.Notes[Expansion][Raid] and AvyrRaidTools_DB.Notes[Expansion][Raid][Boss] then 
				SelectedNote.Key = Expansion .. "\023" .. Raid .. "\023" .. Boss .. "\023" .. Index
				SelectedNote.Expansion = Expansion
				SelectedNote.Raid = Raid
				SelectedNote.Boss = Boss
				SelectedNote.Index = Index
			end 
		end 
	end 

	if Window then 
		if RefreshList then 
			local SO = Window.TabDisplay:Clear(true)
			for ExpansionID,_ in ipairs(_ARTG.DataFuncs.GetRaidInfo("exp.list")) do 
				local ExpansionName = _ARTG.DataFuncs.GetRaidInfo("exp.data.name",ExpansionID)
				if AvyrRaidTools_DB.Notes[ExpansionID] then 
					for _,RaidID in ipairs(_ARTG.DataFuncs.GetRaidInfo("raid.list",ExpansionID)) do 
						if AvyrRaidTools_DB.Notes[ExpansionID][RaidID] then 
							local RaidName = _ARTG.DataFuncs.GetRaidInfo("raid.data.name",RaidID,ExpansionID)
							for _,BossID in ipairs(_ARTG.DataFuncs.GetRaidInfo("boss.list",RaidID,ExpansionID)) do 
								if AvyrRaidTools_DB.Notes[ExpansionID][RaidID][BossID] then 
									local BossName = _ARTG.DataFuncs.GetRaidInfo("boss.data.name",BossID,RaidID,ExpansionID)
									for NoteIndex,Note in ipairs(AvyrRaidTools_DB.Notes[ExpansionID][RaidID][BossID]) do 
										Window.TabDisplay:AddItem(Note.Name,ExpansionID .. "\023" .. RaidID .. "\023" .. BossID .. "\023" .. NoteIndex,false,ExpansionName,RaidName,BossName)
									end 
								end 
							end 
							if AvyrRaidTools_DB.Notes[ExpansionID][RaidID]["Other"] then 
								for NoteIndex,Note in ipairs(AvyrRaidTools_DB.Notes[ExpansionID][RaidID]["Other"]) do 
									if Note.Name then 
										Window.TabDisplay:AddItem(Note.Name,ExpansionID.."\023".. RaidID.."\023Other\023" .. NoteIndex,false,ExpansionName, RaidName,Loc:Translation("OTHER"))
									end
								end 
							end 
						end 
					end 
					if AvyrRaidTools_DB.Notes[ExpansionID]["Other"] then 
						for NoteIndex,Note in ipairs(AvyrRaidTools_DB.Notes[ExpansionID]["Other"]) do 
							if Note.Name then 
								Window.TabDisplay:AddItem(Note.Name,ExpansionID.."\023Other\023nil\023" .. NoteIndex,false,ExpansionName,Loc:Translation("OTHER"))
							end
						end 
					end 
				end 
			end 
			if AvyrRaidTools_DB.Notes["Other"] then 
				for NoteIndex,Note in ipairs(AvyrRaidTools_DB.Notes["Other"]) do 
					if Note.Name then 
						Window.TabDisplay:AddItem(Note.Name,"Other\023nil\023nil\023" .. NoteIndex,false,Loc:Translation("OTHER"))
					end
				end 
			end 
			if AvyrRaidTools_DB.Notes["Deprecated"] then 
				for NoteIndex,Note in ipairs(AvyrRaidTools_DB.Notes["Deprecated"]) do 
					if Note.Name then 
						Window.TabDisplay:AddItem(Note.Name,"Deprecated\023nil\023nil\023" .. NoteIndex,false,Loc:Translation("DEPRECATED"))
					end
				end 
			end 
			if SelectedNote.Key then 
				local ExpansionName,RaidName,BossName
				if SelectedNote.Expansion ~= "Other" and SelectedNote.Expansion ~= "Deprecated" then 
					ExpansionName = _ARTG.DataFuncs.GetRaidInfo("exp.data.name",SelectedNote.Expansion)
					if SelectedNote.Raid ~= "Other" then 
						RaidName = _ARTG.DataFuncs.GetRaidInfo("raid.data.name",SelectedNote.Raid,SelectedNote.Expansion)
						if SelectedNote.Boss ~= "Other" then 
							BossName = _ARTG.DataFuncs.GetRaidInfo("boss.data.name",SelectedNote.Boss,SelectedNote.Raid,SelectedNote.Expansion)
						else 
							BossName = Loc:Translation("OTHER")
						end
					else 
						RaidName = Loc:Translation("OTHER")
					end 
				else 
					if SelectedNote.Expansion == "Other" then 
						ExpansionName = Loc:Translation("OTHER")
					else 
						ExpansionName = Loc:Translation("DEPRECATED")
					end 
				end 
				Window.TabDisplay:SetSelect("Key",SelectedNote.Key,ExpansionName,RaidName,BossName)
			end
			Window.TabDisplay:Refresh(SO)
		end 
		if _ARTG.SV.GetVariable("CurrentNote")["Name"] then 
			Window.LoadedNoteButton:SetDisable(false)
			local RaidName = _ARTG.DataFuncs.GetRaidInfo("raid.data.name",_ARTG.SV.GetVariable("CurrentNote").Raid,_ARTG.SV.GetVariable("CurrentNote").Expansion)
			local BossName = _ARTG.DataFuncs.GetRaidInfo("boss.data.name",_ARTG.SV.GetVariable("CurrentNote").Boss,_ARTG.SV.GetVariable("CurrentNote").Raid,_ARTG.SV.GetVariable("CurrentNote").Expansion)
			Window.LoadedNoteButton:SetText({
				{Text = _ARTG.SV.GetVariable("CurrentNote").Name, FontSize = 15, r = "Normal", HAlign = "LEFT", VAlign = "TOP"},
				{Text = BossName .." - ".. RaidName, FontSize = 11, r = "Normal", HAlign = "LEFT", VAlign = "TOP"},
			})
			Window.SaveLoaded:SetDisable(false)
			Window.ClearLoaded:SetDisable(false)
		else 
			Window.LoadedNoteButton:SetText({
				{Text = Loc:Translation("NO_NOTE_LOADED"), FontSize = 15, r = 1, g = 1, b = 1, HAlign = "LEFT", VAlign = "TOP"},
				{Text = "", FontSize = 11, r = 1, g = 1, b = 1, HAlign = "LEFT", VAlign = "TOP"}
			})
			Window.LoadedNoteButton:SetDisable(true)
			Window.SaveLoaded:SetDisable(true)
			Window.ClearLoaded:SetDisable(true)
		end 
		Editor:LoadNote()
	end 
end 

local SelectedEntries = {}
local function UpdateNoteHeader()
	local NameStr = ""
	local InfoStr = ""
	local Note,InfoString = _ARTG.SV.CheckNoteExists(SelectedNote.Expansion,SelectedNote.Raid,SelectedNote.Boss,SelectedNote.Index)
	if Note then 
		NameStr = Note.Name
		InfoStr = InfoString
	else 
		NameStr = "Error: try another note"
	end 

	Window.NoteHeader:SetText({
		{Text = NameStr, FontSize = 15, r = "Highlight", HAlign = "LEFT", VAlign = "TOP"},
		{Text = InfoStr, FontSize = 11, r = "Normal", HAlign = "LEFT", VAlign = "TOP"},
	})

	table.wipe(SelectedEntries)
	Window:ClearPopup()

	if _ARTG.BossTemplates[SelectedNote.Boss] then 
		if _ARTG.BossTemplates[SelectedNote.Boss]["Templates"] then 
			Window.EntryEditBtnBar.TemplateCreateBtn:SetDisable(false)
			Window.EntryEditBtnBar.TemplateCreateBtn.OnClick = function()
				local globalPopup = Widgets:CallPopup("SpellSequencePopup"..SelectedNote.Boss.."SelectTemplate",Loc:Translation("TEMPLATECREATE_ENTRY"))

				if not globalPopup then 
					return 
				end 
				
				globalPopup:AddRow("Type","LB","Text",Loc:Translation("SELECT_TEMPLATE"))
				for templateIndex,template in ipairs(_ARTG.BossTemplates[SelectedNote.Boss]["Templates"]) do 
					if template.Name then 
						globalPopup:AddRow("Type","DB","Alignment","LEFT","Text",template.Name,"Func",function()
							Widgets:CallPopup("SpellSequencePopup"..SelectedNote.Boss.."SelectTemplate")
							globalPopup = Widgets:CallPopup("SpellSequencePopup"..SelectedNote.Boss.."SelectTemplate",Loc:Translation("TEMPLATECREATE_ENTRY"))
							for i,v in ipairs(template.SpellSequence) do 
								local Header,Note = strsplit(";",v)
								local HeaderString  = _ARTG.SV.NoteEntry("Header","Summary",Header) .. " " .. (Note or "")

								globalPopup:AddRow("Type","DB","Name","TemplateEntry"..i,"Alignment","LEFT","Text",HeaderString,"Func",function(_,value)
									if tContains(SelectedEntries,i) then 
										for subIndex = 1,getn(SelectedEntries) do 
											if SelectedEntries[subIndex] == i then 
												table.remove(SelectedEntries,subIndex)
												break 
											end 
										end 
										globalPopup:ChangeItem("TemplateEntry"..i,"Selected",false)
										if getn(SelectedEntries) < 1 then 
											globalPopup:ChangeItem("SelectedImportBtn","Disable",true)
										end 
									else
										table.insert(SelectedEntries,i)
										globalPopup:ChangeItem("TemplateEntry"..i,"Selected",true)
										globalPopup:ChangeItem("SelectedImportBtn","Disable",false)
									end
								end)
							end
							globalPopup:AddRow("Type","DB","Name","SelectedImportBtn","Text",Loc:Translation("IMPORT_SELECTED"),"Disable",true,"Func",function(_,value)
								for _,i in ipairs(SelectedEntries) do 
									local v = template.SpellSequence[i]
									local Header,NoteContent = strsplit(";",v)
									if Header then
										Note.Data = Note.Data or {}
										insert(Note.Data,{Header,(NoteContent or "")})
									end
								end
								Editor:UpdateNoteContent(true)
								Widgets:CallPopup("SpellSequencePopup"..SelectedNote.Boss.."SelectTemplate")
							end)
							globalPopup:AddRow("Type","DB","Text",Loc:Translation("IMPORT_ALL"),"Func",function(_,value)
								Note.Data = Note.Data or {}
								for i,v in ipairs(template.SpellSequence) do 
									local Header,NoteContent = strsplit(";",v)
									if Header then
										Note.Data = Note.Data or {}
										insert(Note.Data,{Header,(NoteContent or "")})
									end
								end
								Editor:UpdateNoteContent(true)
								Widgets:CallPopup("SpellSequencePopup"..SelectedNote.Boss.."SelectTemplate")
							end)
						end)
					end
				end
				globalPopup:AddRow("Type","DB","Text",Loc:Translation("CANCEL"),"Func",function()
					Widgets:CallPopup("SpellSequencePopup"..SelectedNote.Boss.."SelectTemplate")
				end)
			end
		else 
			Window.EntryEditBtnBar.TemplateCreateBtn:SetDisable(true)
			Window.EntryEditBtnBar.TemplateCreateBtn.OnClick = nil
		end 
	end
end 

Editor.LoadNote = function(self)
	local Note = _ARTG.SV.CheckNoteExists(SelectedNote.Expansion,SelectedNote.Raid,SelectedNote.Boss,SelectedNote.Index)
	if Note then
		if not Window.BtnBar then 
			Window.BtnBar = Widgets:CreateFrame(Window)
			Window.BtnBar:Size(Window:GetWidth() - Window.TabDisplay:GetWidth() - 2*BorderSize - 3*Padding,20 + 2*Padding + 2*BorderSize)
			Window.BtnBar:SetPoint("TOPLEFT",Window.LoadedNoteLB,"TOPRIGHT",Widgets.Padding,0)
			Window.BtnBar:SetThemedBackdrop()

			local BtnSize = (Window.BtnBar:GetWidth() - 6*Widgets.Padding - 2*BorderSize)/5

			Window.BtnBar.DeleteBtn = Widgets:CreateButton(Window.BtnBar)
			Window.BtnBar.DeleteBtn:Size(BtnSize,20)
			Window.BtnBar.DeleteBtn:SetPoint("TOPLEFT",Window.BtnBar,"TOPLEFT",Widgets.Padding + Widgets.BorderSize,-Widgets.Padding-Widgets.BorderSize)
			Window.BtnBar.DeleteBtn:SetText(Loc:Translation("DELETE"),nil,"Highlight")
	
			Window.BtnBar.DuplicateBtn = Widgets:CreateButton(Window.BtnBar)
			Window.BtnBar.DuplicateBtn:Size(BtnSize,20)
			Window.BtnBar.DuplicateBtn:SetPoint("TOPLEFT",Window.BtnBar.DeleteBtn,"TOPRIGHT",Widgets.Padding,0)
			Window.BtnBar.DuplicateBtn:SetText(Loc:Translation("DUPLICATE"),nil,"Highlight")
			
			Window.BtnBar.LoadBtn = Widgets:CreateButton(Window.BtnBar)
			Window.BtnBar.LoadBtn:Size(BtnSize,20)
			Window.BtnBar.LoadBtn:SetText(Loc:Translation("LOAD"),nil,"Highlight")
			Window.BtnBar.LoadBtn:SetPoint("TOPLEFT",Window.BtnBar.DuplicateBtn,"TOPRIGHT",Widgets.Padding,0)

			Window.BtnBar.SendBtn = Widgets:CreateButton(Window.BtnBar)
			Window.BtnBar.SendBtn:Size(BtnSize,20)
			Window.BtnBar.SendBtn:SetText(Loc:Translation("SEND"),nil,"Highlight")
			Window.BtnBar.SendBtn:SetPoint("TOPLEFT",Window.BtnBar.LoadBtn,"TOPRIGHT",Widgets.Padding,0)

			Window.BtnBar.ExportBtn = Widgets:CreateButton(Window.BtnBar)
			Window.BtnBar.ExportBtn:Size(BtnSize,20)
			Window.BtnBar.ExportBtn:SetText(Loc:Translation("EXPORT"),nil,"Highlight")
			Window.BtnBar.ExportBtn:SetPoint("TOPLEFT",Window.BtnBar.SendBtn,"TOPRIGHT",Widgets.Padding,0)
		end 

		Window.BtnBar.DeleteBtn.OnClick = function()
			Editor:EditNote("Delete",SelectedNote.Expansion,SelectedNote.Raid,SelectedNote.Boss,SelectedNote.Index)
		end
		Window.BtnBar.DuplicateBtn.OnClick = function()
			Editor:EditNote("Duplicate",SelectedNote.Expansion,SelectedNote.Raid,SelectedNote.Boss,SelectedNote.Index)
		end   
		Window.BtnBar.LoadBtn.OnClick = function()
		   -- _ARTG.DataFuncs.NoteData("current.set.selected",Note,expansionIndex,raidID,bossID)

			
			local ClonedNote = {}
			ClonedNote.Name = Note.Name
			ClonedNote.Description = Note.Description
			ClonedNote.Expansion = SelectedNote.Expansion
			ClonedNote.Raid = SelectedNote.Raid
			ClonedNote.Boss = SelectedNote.Boss
			if Note.Data then 
				ClonedNote.Data = {}
				for i,v in ipairs(Note.Data) do 
					insert(ClonedNote.Data,{v[1],v[2]})
				end 
			end 
			_ARTG.SV.SaveVariable("CurrentNote",ClonedNote)
		end
		Window.BtnBar.SendBtn.OnClick = function()
			_ARTG.Coms.Send("Prepare",Note.Name,SelectedNote.Expansion,SelectedNote.Raid,SelectedNote.Boss,SelectedNote.Index)
		end 
		Window.BtnBar.ExportBtn.OnClick = function()
			_ARTG.Coms.ExportNote(Note.Name,Note.Description,Note.Data,SelectedNote.Expansion,SelectedNote.Raid,SelectedNote.Boss)
		end

		if not Window.NoteHeader then 
			Window.NoteHeader = Widgets:CreateFrame(Window)
			Window.NoteHeader:Size(Window:GetWidth() - Window.TabDisplay:GetWidth() - 2*BorderSize - 3*Padding,20 + 2*Padding + 2*BorderSize)
			Window.NoteHeader:SetPoint("TOPLEFT",Window.BtnBar,"BOTTOMLEFT",0,-Widgets.Padding)
			Window.NoteHeader:SetThemedBackdrop()

			Window.NoteHeader.EditBtn = Widgets:CreateButton(Window.NoteHeader) 
			Window.NoteHeader.EditBtn:Size(75,20)
			Window.NoteHeader.EditBtn:SetText(Loc:Translation("EDIT"),nil,"Highlight")
			Window.NoteHeader.EditBtn:SetPoint("TOPRIGHT",-Widgets.Padding-Widgets.BorderSize,-Widgets.Padding-Widgets.BorderSize)
		end 

		Window.NoteHeader.EditBtn.OnClick = function()
			Editor:NoteInfoEdit(Note.Name,Note.Description,SelectedNote.Expansion,SelectedNote.Raid,SelectedNote.Boss, function(Name,Description,Expansion,Raid,Boss)
				if SelectedNote.Expansion ~= Expansion or SelectedNote.Raid ~= Raid or SelectedNote.Boss ~= Boss then 
					local OldDirectory = _ARTG.SV.CheckNoteExists(SelectedNote.Expansion,SelectedNote.Raid,SelectedNote.Boss,SelectedNote.Index, true)
					if OldDirectory then 
						local DataClone
						if Note.Data then 
							DataClone = {}
							for i,v in ipairs(Note.Data) do 
								insert(DataClone,{v[1],v[2]})
							end 
						end 
						remove(OldDirectory,SelectedNote.Index)
						Editor:EditNote("New",Name,Description,DataClone,Expansion,Raid,Boss)
					end 
				else 
					Note.Description = Description
					Note.Name = Name
					Editor:Refresh(true)
				end 
			end)
		end 

		if not Window.EntryEditBtnBar then 
			Window.EntryEditBtnBar = Widgets:CreateFrame(Window)
			Window.EntryEditBtnBar:Size(Window.BtnBar:GetWidth(),20 + 2*Padding + 2*BorderSize)
			Window.EntryEditBtnBar:SetPoint("TOPLEFT",Window.NoteHeader,"BOTTOMLEFT",0,-Widgets.Padding)
			Window.EntryEditBtnBar:SetThemedBackdrop()

			local BtnSize = (Window.EntryEditBtnBar:GetWidth() - 6*Widgets.Padding - 2*BorderSize)/4

			Window.EntryEditBtnBar.AddEntryBtn = Widgets:CreateButton(Window.EntryEditBtnBar)
			Window.EntryEditBtnBar.AddEntryBtn:Size(BtnSize,20)
			Window.EntryEditBtnBar.AddEntryBtn:SetPoint("TOPLEFT",Window.EntryEditBtnBar,"TOPLEFT",Widgets.Padding + Widgets.BorderSize,-Widgets.Padding-Widgets.BorderSize)
			Window.EntryEditBtnBar.AddEntryBtn:SetText(Loc:Translation("ADD_ENTRY"),nil,"Highlight")
			Window.EntryEditBtnBar.AddEntryBtn.OnClick = function()
				Editor:NoteEntryConditionEdit("",SelectedNote.Boss,function(NewHeader)
					Note.Data = Note.Data or {}
					insert(Note.Data,{NewHeader,""})
					Editor:UpdateNoteContent(true)
				end)
			end
			--[[
			Window.EntryEditBtnBar.DuplicateEntryBtn = Widgets:CreateButton(Window.EntryEditBtnBar)
			Window.EntryEditBtnBar.DuplicateEntryBtn:Size(BtnSize,20)
			Window.EntryEditBtnBar.DuplicateEntryBtn:SetPoint("TOPLEFT",Window.EntryEditBtnBar.AddEntryBtn,"TOPRIGHT",Widgets.Padding,0)
			Window.EntryEditBtnBar.DuplicateEntryBtn:SetText(Loc:Translation("DUPLICATE_ENTRY"),nil,"Highlight")
			Window.EntryEditBtnBar.DuplicateEntryBtn.OnClick = function()

			end

			Window.EntryEditBtnBar.QuickCreateEntry = Widgets:CreateButton(Window.EntryEditBtnBar)
			Window.EntryEditBtnBar.QuickCreateEntry:Size(BtnSize,20)
			Window.EntryEditBtnBar.QuickCreateEntry:SetPoint("TOPLEFT",Window.EntryEditBtnBar.DuplicateEntryBtn,"TOPRIGHT",Widgets.Padding,0)
			Window.EntryEditBtnBar.QuickCreateEntry:SetText(Loc:Translation("QUICKCREATE_ENTRY"),nil,"Highlight")
			Window.EntryEditBtnBar.QuickCreateEntry.OnClick = function()

			end]]

			Window.EntryEditBtnBar.TemplateCreateBtn = Widgets:CreateButton(Window.EntryEditBtnBar)
			Window.EntryEditBtnBar.TemplateCreateBtn:Size(BtnSize,20)
			Window.EntryEditBtnBar.TemplateCreateBtn:SetPoint("TOPLEFT",Window.EntryEditBtnBar.AddEntryBtn,"TOPRIGHT",Widgets.Padding,0)
			Window.EntryEditBtnBar.TemplateCreateBtn:SetText(Loc:Translation("TEMPLATECREATE_ENTRY"),nil,"Highlight")
	
	--[[
			Window.BtnBar.DuplicateBtn = Widgets:CreateButton(Window.BtnBar)
			Window.BtnBar.DuplicateBtn:Size(BtnSize,20)
			Window.BtnBar.DuplicateBtn:SetPoint("TOPLEFT",Window.BtnBar.AddEntryBtn,"TOPRIGHT",Widgets.Padding,0)
			Window.BtnBar.DuplicateBtn:SetText(Loc:Translation("DUPLICATE"),nil,"Highlight")
			
			Window.BtnBar.LoadBtn = Widgets:CreateButton(Window.BtnBar)
			Window.BtnBar.LoadBtn:Size(BtnSize,20)
			Window.BtnBar.LoadBtn:SetText(Loc:Translation("LOAD"),nil,"Highlight")
			Window.BtnBar.LoadBtn:SetPoint("TOPLEFT",Window.BtnBar.DuplicateBtn,"TOPRIGHT",Widgets.Padding,0)

			Window.BtnBar.SendBtn = Widgets:CreateButton(Window.BtnBar)
			Window.BtnBar.SendBtn:Size(BtnSize,20)
			Window.BtnBar.SendBtn:SetText(Loc:Translation("SEND"),nil,"Highlight")
			Window.BtnBar.SendBtn:SetPoint("TOPLEFT",Window.BtnBar.LoadBtn,"TOPRIGHT",Widgets.Padding,0)

			Window.BtnBar.ExportBtn = Widgets:CreateButton(Window.BtnBar)
			Window.BtnBar.ExportBtn:Size(BtnSize,20)
			Window.BtnBar.ExportBtn:SetText(Loc:Translation("EXPORT"),nil,"Highlight")
			Window.BtnBar.ExportBtn:SetPoint("TOPLEFT",Window.BtnBar.SendBtn,"TOPRIGHT",Widgets.Padding,0)]]
		end 

		
		UpdateNoteHeader()
		Editor:UpdateNoteContent()
	else 
		if Window.BtnBar then 
			Window.BtnBar:Release()
			Window.BtnBar = nil
		end 
		if Window.NoteHeader then 
			Window.NoteHeader:Release()
			Window.NoteHeader = nil
		end 
		if Window.NoteContentTab then 
			Window.NoteContentTab:Release()
			Window.NoteContentTab = nil
		end 
		if Window.CDAnchorFrame then 
			Window.CDAnchorFrame:Release()
			Window.CDAnchorFrame = nil
		end         
		if Window.CDFlyoutBtn then 
			Window.CDFlyoutBtn:Release()
			Window.CDFlyoutBtn = nil
		end 
	end 
end 

local CDsPerRow = 3
local function PickupCooldown(Cooldown,OriginEntry,OriginPosition)
	if Window.CDFlyoutBtn then 
		Window.CDFlyoutBtn:Release()
		Window.CDFlyoutBtn = nil
	end 

	local DisplayString,CD,Name = _ARTG.SV.NoteEntry("CD","Display",Cooldown)
	local Note = _ARTG.SV.CheckNoteExists(SelectedNote.Expansion,SelectedNote.Raid,SelectedNote.Boss,SelectedNote.Index)

	Window.CDFlyoutBtn = Widgets:CreateFrame(Window)
	Window.CDFlyoutBtn:SetThemedBackdrop()
	Window.CDFlyoutBtn:SetFrameStrata("FULLSCREEN_DIALOG")
	Window.CDFlyoutBtn:SetText(DisplayString,15,"Highlight",nil,nil,"LEFT","CENTER")
	Window.CDFlyoutBtn:Size(100,25)

	local PrevNote
	if OriginEntry then 
		local NoteString,CDs  = _ARTG.SV.NoteEntry("Note","Summary", Note.Data[OriginEntry.EntryIndex][2])
		PrevNote = Note.Data[OriginEntry.EntryIndex][2]
		CDs[OriginPosition] = ""
		Note.Data[OriginEntry.EntryIndex][2] = _ARTG.SV.NoteEntry("Note","Pack",NoteString,CDs)
		Editor.UpdateEntryNote(OriginEntry)
	end

	Window.CDFlyoutBtn:SetScript("OnUpdate",function()
		local MouseX, MouseY = GetCursorPosition()
		local Scale = Window.CDFlyoutBtn:GetEffectiveScale() 
		MouseX = MouseX / Scale
		MouseY = MouseY / Scale
		Window.CDFlyoutBtn:SetPoint("CENTER",UIParent,"BOTTOMLEFT", MouseX, MouseY)
		if not IsMouseButtonDown() then 
			Window.CDFlyoutBtn:Release()
			Window.CDFlyoutBtn = nil

			local EntryIndex = 1
			while Window.NoteContentTab["Entry"..EntryIndex] do 
				if Window.NoteContentTab["Entry"..EntryIndex]:IsMouseOver() then 
					if Window.NoteContentTab["Entry"..EntryIndex].ARTNumOfCDs == 0 then 
						Note.Data[Window.NoteContentTab["Entry"..EntryIndex].EntryIndex][2] = Note.Data[Window.NoteContentTab["Entry"..EntryIndex].EntryIndex][2] .. Cooldown
						Editor.UpdateEntryNote(Window.NoteContentTab["Entry"..EntryIndex])
						return  
					else  
						local CDIndex = 1 
						local NoteString,CDs  = _ARTG.SV.NoteEntry("Note","Summary", Note.Data[Window.NoteContentTab["Entry"..EntryIndex].EntryIndex][2])
						while Window.NoteContentTab["Entry"..EntryIndex]["CDFrame"..CDIndex] do 
							local CDx,CDy = Window.NoteContentTab["Entry"..EntryIndex]["CDFrame"..CDIndex]:GetCenter()
							local CDScale = Window.NoteContentTab["Entry"..EntryIndex]["CDFrame"..CDIndex]:GetEffectiveScale() 
							--CDx = CDx / CDScale
							--CDy = CDy / CDScale
							if MouseX <= CDx and MouseY <= Window.NoteContentTab["Entry"..EntryIndex]["CDFrame"..CDIndex]:GetTop() and MouseY >= Window.NoteContentTab["Entry"..EntryIndex]["CDFrame"..CDIndex]:GetBottom() then 
								break 
							elseif CDIndex%CDsPerRow == 0 and MouseY <= Window.NoteContentTab["Entry"..EntryIndex]["CDFrame"..CDIndex]:GetTop() and MouseY >= Window.NoteContentTab["Entry"..EntryIndex]["CDFrame"..CDIndex]:GetBottom() then
								CDIndex = CDIndex + 1
								break
							end 
							CDIndex = CDIndex + 1
						end
						--insert(CDs,CDIndex,Cooldown)
						if CDIndex > getn(CDs) then 
							NoteString = NoteString .. "/cd"
							insert(CDs,Cooldown)
						else 
							CDs[CDIndex] = Cooldown..CDs[CDIndex]
						end 

						--[[
						local pos = 1
						for slashCDIndex = 1,CDIndex do 
							print(pos)
							local StartFind,EndFind = NoteString:find("/cd",pos)
							print(StartFind,EndFind)
							if StartFind then 
								pos = EndFind + 1
							else 
								NoteString = NoteString .. "/cd"
								pos = nil
								break
							end 
						end 
						print(pos)
						if pos then 
							NoteString = NoteString:sub(1,pos-1).."/cd"..NoteString:sub(pos)
						end ]]
						Note.Data[Window.NoteContentTab["Entry"..EntryIndex].EntryIndex][2] = _ARTG.SV.NoteEntry("Note","Pack",NoteString,CDs)
						Editor.UpdateEntryNote(Window.NoteContentTab["Entry"..EntryIndex])
						return 
					end 
				end 
				EntryIndex = EntryIndex + 1
			end 
			if PrevNote then 
				Note.Data[OriginEntry.EntryIndex][2] = PrevNote
				Editor.UpdateEntryNote(OriginEntry)
			end 
		end 
	end)
end 

Editor.UpdateEntryNote = function(Entry)
	local i = 1
	while Entry["CDFrame"..i] do 
		Entry["CDFrame"..i]:Release()
		Entry["CDFrame"..i] = nil
		i = i + 1
	end 
	local Note = _ARTG.SV.CheckNoteExists(SelectedNote.Expansion,SelectedNote.Raid,SelectedNote.Boss,SelectedNote.Index)
	local NoteString,CDs  = _ARTG.SV.NoteEntry("Note","Summary", Note.Data[Entry.EntryIndex][2])
	
	Entry.NoteTextBox:SetValue(NoteString)
	Entry.NoteTextBox.OnValueChanged = function(self,value)
		Note.Data[Entry.EntryIndex][2] = _ARTG.SV.NoteEntry("Note","Pack",value,CDs)
		Editor.UpdateEntryNote(Entry)
	end

	local Rows = 0
	if CDs then 
		Entry.ARTNumOfCDs = getn(CDs)
		for i = 1,getn(CDs) do 
			local v = CDs[i]
			Entry["CDFrame"..i] = Widgets:CreateFrame(Entry)
			Entry["CDFrame"..i]:SetThemedBackdrop()  
			Entry["CDFrame"..i]:Size(150 ,25)
			local RowNum = ceil(i/CDsPerRow)
			Entry["CDFrame"..i]:SetPoint("TOPLEFT",Entry.NoteTextBox,"BOTTOMLEFT",(150 + Padding)*((i - 3*(RowNum - 1)) - 1),-Padding - (Padding + 25)*(RowNum - 1))
			local DisplayString,CD,Name = _ARTG.SV.NoteEntry("CD","Display",v)
			Entry["CDFrame"..i]:SetText(DisplayString,15,"Highlight",nil,nil,"LEFT","CENTER")
			local Tooltip = GetSpellInfo(CD)
			if Name ~= "" then 
				Tooltip = Tooltip.."\n"..Name
			end 
			Tooltip = Tooltip.."\n\n"
			Tooltip = Tooltip..Loc:Translation("LEFT_CLICK_HOLD_TO_MOVE")
			Tooltip = Tooltip.."\n"
			Tooltip = Tooltip..Loc:Translation("RIGHT_CLICK_TO_EDIT_OR_DELETE")

			Entry["CDFrame"..i]:SetTooltip(Tooltip)

			Entry["CDFrame"..i].FavoriteBtn = Widgets:CreateFrame(Entry["CDFrame"..i])
			Entry["CDFrame"..i].FavoriteBtn:Size(20,20)
			Entry["CDFrame"..i].FavoriteBtn:SetPoint("TOPRIGHT")

			if _ARTG.SV.CooldownEdit("IsFavorite",v) then 
				Entry["CDFrame"..i].FavoriteBtn:SetIcon("TexturePath",Widgets:GetIcon("StarMask"),"Theme","Highlight")
				Entry["CDFrame"..i].FavoriteBtn:SetScript("OnMouseDown",function(_,btn)
					_ARTG.SV.CooldownEdit("RemoveFavorite",v)
				end)
			else 
				Entry["CDFrame"..i].FavoriteBtn:SetIcon("TexturePath",Widgets:GetIcon("StarOutlineMask"),"Theme","Highlight")
				Entry["CDFrame"..i].FavoriteBtn:SetScript("OnMouseDown",function(_,btn)
					_ARTG.SV.CooldownEdit("AddFavorite",v)
				end)
			end 


			Entry["CDFrame"..i]:SetScript("OnMouseDown",function(_,btn)
				if Window.CDFlyoutBtn then 
					Window.CDFlyoutBtn:Release()
					Window.CDFlyoutBtn = nil
				end 
				if btn == "LeftButton" then 
					PickupCooldown(v,Entry,i)
				else       
					Widgets:DropdownCall(Entry["CDFrame"..i],{
						Loc:Translation("EDIT"),
						Loc:Translation("DELETE"),
					},function(self,value,SelectIndex)
						if SelectIndex == 1 then 
							Editor:NoteCooldownEdit(v,function(NewCDLink)
								CDs[i] = NewCDLink
								Note.Data[Entry.EntryIndex][2] = _ARTG.SV.NoteEntry("Note","Pack",NoteString,CDs)
								Editor.UpdateEntryNote(Entry)
							end)
						elseif SelectIndex == 2 then 
							CDs[i] = ""
							Note.Data[Entry.EntryIndex][2] = _ARTG.SV.NoteEntry("Note","Pack",NoteString,CDs)
							Editor.UpdateEntryNote(Entry)
						end 
					end)
 
				end
			end)
		end 
		Rows = ceil(getn(CDs)/CDsPerRow)
	else 
		Entry.ARTNumOfCDs = 0
	end 

	--BorderSize + Padding + 20 + 15 + Padding + 20 + Padding + BorderSize + (Rows * (20 + Padding))
	local NewHeight = Rows * (25 + Padding) + 55 + 3*Padding + 2*BorderSize
	local PrevHeight = Entry:GetHeight()
	if PrevHeight ~= NewHeight then 
		Entry:Size(nil,NewHeight)
		local newContentHeight = Window.NoteContentTab.Content:GetHeight() - PrevHeight + NewHeight
		Window.NoteContentTab.Content:Size(nil,newContentHeight)
	end
end 

Editor.UpdateAllEntryNote = function()
	if Window and Window.NoteContentTab then 
		local EntryIndex = 1
		while Window.NoteContentTab["Entry"..EntryIndex] do 
			Editor.UpdateEntryNote(Window.NoteContentTab["Entry"..EntryIndex])
			EntryIndex = EntryIndex + 1
		end 
	end 
end 

Editor.UpdateNoteContent = function(self,MaxScroll)
	local ScrollOffset = 0
	if Window.NoteContentTab then 
		ScrollOffset = Window.NoteContentTab.ScrollOffset
		Window.NoteContentTab:Release()
		Window.NoteContentTab = nil
	end 
	Window.NoteContentTab = Widgets:CreateAdancedScrollFrame(Window)
	Window.NoteContentTab:SetPoint("TOPLEFT",Window.EntryEditBtnBar,"BOTTOMLEFT",0,-Padding)
	Window.NoteContentTab:Size(col2,Window:GetHeight() - Window.Header:GetHeight() - Window.BtnBar:GetHeight() - Window.EntryEditBtnBar:GetHeight() - Window.NoteHeader:GetHeight() - 6*Padding - 2*BorderSize)
	Window.NoteContentTab.OnContentWidthChanged = function()
		local EntryIndex = 1
		while Window.NoteContentTab["Entry"..EntryIndex] do 
			Window.NoteContentTab["Entry"..EntryIndex]:Size(Window.NoteContentTab.Content:GetWidth() - 2*Padding)
			EntryIndex = EntryIndex + 1
		end 
		--Window.NoteContentTab["AddEntry"]:Size(Window.NoteContentTab.Content:GetWidth() - 2*Padding)
	end

	local Note = _ARTG.SV.CheckNoteExists(SelectedNote.Expansion,SelectedNote.Raid,SelectedNote.Boss,SelectedNote.Index)
	local PrevFrame 
	local ContentWidth = Window.NoteContentTab.Content:GetWidth() - 2*Padding
	local ContentHeight = 2*Padding
	if Note and Note.Data then
		_ARTG.SV.NoteSort(Note.Data)
		for i,v in ipairs(Note.Data) do 
			Window.NoteContentTab["Entry"..i] = Widgets:CreateFrame(Window.NoteContentTab.Content)
			Window.NoteContentTab["Entry"..i]:SetThemedBackdrop()
			Window.NoteContentTab["Entry"..i]:Size(ContentWidth,80)
		
			Window.NoteContentTab["Entry"..i].EntryIndex = i

			local DisplayString  = _ARTG.SV.NoteEntry("Header","Summary",v[1])

			if not v[1]:find("T:") and select(6,strsplit(":",v[1])) ~= "1" then 
				Window.NoteContentTab["Entry"..i].UpBtn = Widgets:CreateButton(Window.NoteContentTab["Entry"..i])
				Window.NoteContentTab["Entry"..i].UpBtn:SetPoint("TOPLEFT",BorderSize + Padding,-BorderSize - Padding)
				Window.NoteContentTab["Entry"..i].UpBtn:Size(20,20)
				Window.NoteContentTab["Entry"..i].UpBtn:SetIcon("TexturePath",Widgets:GetIcon("ArrowHeadMask"),"Theme","Highlight","Rotation",135,"Zoom",0.2)
				--Window.NoteContentTab["Entry"..i].UpBtn.Icon:SetTexCoord(-0.2,0.5,0.5,-0.2,0.5, 1.2,1.2,0.5)
				Window.NoteContentTab["Entry"..i].UpBtn.OnClick = function(self)
					if i ~= 1 then 
						remove(Note.Data,i)
						insert(Note.Data,i-1,v)
						Editor:UpdateNoteContent()
					end
				end

				Window.NoteContentTab["Entry"..i].DownBtn = Widgets:CreateButton(Window.NoteContentTab["Entry"..i])
				Window.NoteContentTab["Entry"..i].DownBtn:SetPoint("TOPLEFT",Window.NoteContentTab["Entry"..i].UpBtn, "TOPRIGHT",Padding,0)
				Window.NoteContentTab["Entry"..i].DownBtn:Size(20,20)
				Window.NoteContentTab["Entry"..i].DownBtn:SetIcon("TexturePath",Widgets:GetIcon("ArrowHeadMask"),"Theme","Highlight","Rotation",-45,"Zoom",0.2)
				--Window.NoteContentTab["Entry"..i].DownBtn.Icon:SetTexCoord(1.2,0.5,0.5,1.2,0.5,-0.2,-0.2,0.5)
				Window.NoteContentTab["Entry"..i].DownBtn.OnClick = function(self)
					if i ~= getn(Note.Data) then 
						remove(Note.Data,i)
						insert(Note.Data,i+1,v)
						Editor:UpdateNoteContent()
					end
				end
			end 
			--Window.NoteContentTab["Entry"..i].:SetIcon(Widgets:GetIcon("ArrowHeadMask"),0,1,0,1, "Highlight",nil,nil,true, 225, true)
			

			Window.NoteContentTab["Entry"..i].DeleteBtn = Widgets:CreateButton(Window.NoteContentTab["Entry"..i])
			Window.NoteContentTab["Entry"..i].DeleteBtn:SetPoint("TOPRIGHT",Window.NoteContentTab["Entry"..i], "TOPRIGHT",-BorderSize - Padding,-BorderSize - Padding)
			Window.NoteContentTab["Entry"..i].DeleteBtn:CloseButtonTexture();
			Window.NoteContentTab["Entry"..i].DeleteBtn:Size(20,20)
			Window.NoteContentTab["Entry"..i].DeleteBtn.OnClick = function()
				remove(Note.Data,i)
				Editor:UpdateNoteContent()
			end

			Window.NoteContentTab["Entry"..i].HeaderBtn = Widgets:CreateButton(Window.NoteContentTab["Entry"..i])
			if Window.NoteContentTab["Entry"..i].DownBtn then 
				Window.NoteContentTab["Entry"..i].HeaderBtn:SetPoint("TOPLEFT",Window.NoteContentTab["Entry"..i].DownBtn, "TOPRIGHT",Padding,0)
			else 
				Window.NoteContentTab["Entry"..i].HeaderBtn:SetPoint("TOPLEFT",BorderSize + Padding,-BorderSize - Padding)
			end 
			Window.NoteContentTab["Entry"..i].HeaderBtn:SetPoint("TOPRIGHT",Window.NoteContentTab["Entry"..i].DeleteBtn, "TOPLEFT",- Padding,0)
			Window.NoteContentTab["Entry"..i].HeaderBtn:Size(nil,20)
			Window.NoteContentTab["Entry"..i].HeaderBtn:SetText(DisplayString,nil,"Highlight",nil,nil,"LEFT")
			Window.NoteContentTab["Entry"..i].HeaderBtn.OnClick = function()
				Editor:NoteEntryConditionEdit(v[1],SelectedNote.Boss,function(NewHeader)
					v[1] = NewHeader
					Editor:UpdateNoteContent()
				end)
			end


			Window.NoteContentTab["Entry"..i].NoteLB = Widgets:FetchFontString(Window.NoteContentTab["Entry"..i])
			Window.NoteContentTab["Entry"..i].NoteLB:SetText(Loc:Translation("NOTE"))
			Window.NoteContentTab["Entry"..i].NoteLB:SetHeight(20)
			Window.NoteContentTab["Entry"..i].NoteLB:SetJustifyH("LEFT")
			Window.NoteContentTab["Entry"..i].NoteLB:SetJustifyV("TOP")
			Widgets:SetThemedColor(Window.NoteContentTab["Entry"..i].NoteLB,"Highlight")
			if Window.NoteContentTab["Entry"..i].UpBtn then 
				Window.NoteContentTab["Entry"..i].NoteLB:SetPoint("TOPLEFT", Window.NoteContentTab["Entry"..i].UpBtn,"BOTTOMLEFT",0,-Padding)
			else 
				Window.NoteContentTab["Entry"..i].NoteLB:SetPoint("TOPLEFT", Window.NoteContentTab["Entry"..i].HeaderBtn,"BOTTOMLEFT",0,-Padding)
			end 
			Window.NoteContentTab["Entry"..i].NoteLB:SetPoint("TOPRIGHT", Window.NoteContentTab["Entry"..i].DeleteBtn,"BOTTOMRIGHT",0,-Padding)
		

			Window.NoteContentTab["Entry"..i].NoteTextBox = Widgets:CreateBasicTextBox(Window.NoteContentTab["Entry"..i], false, "LEFT")
			if Window.NoteContentTab["Entry"..i].UpBtn then 
				Window.NoteContentTab["Entry"..i].NoteTextBox:SetPoint("TOPLEFT", Window.NoteContentTab["Entry"..i].UpBtn ,"BOTTOMLEFT",0,-Padding-15)
			else 
				Window.NoteContentTab["Entry"..i].NoteTextBox:SetPoint("TOPLEFT", Window.NoteContentTab["Entry"..i].HeaderBtn ,"BOTTOMLEFT",0,-Padding-15)
			end 
			Window.NoteContentTab["Entry"..i].NoteTextBox:SetPoint("TOPRIGHT", Window.NoteContentTab["Entry"..i].DeleteBtn,"BOTTOMRIGHT",0,-Padding-15)
			Window.NoteContentTab["Entry"..i].NoteTextBox:Size(nil,20)

			Editor.UpdateEntryNote(Window.NoteContentTab["Entry"..i])

			if PrevFrame then 
				Window.NoteContentTab["Entry"..i]:SetPoint("TOP",PrevFrame,"Bottom",0,-Padding)
			else 
				Window.NoteContentTab["Entry"..i]:SetPoint("TOP",Window.NoteContentTab.Content,"TOP",0,-Padding)
			end 
			PrevFrame = Window.NoteContentTab["Entry"..i]
			ContentHeight = ContentHeight + Window.NoteContentTab["Entry"..i]:GetHeight() + Padding
		end 
	end 

	Window.NoteContentTab.Content:Size(nil,ContentHeight)
	if MaxScroll then 
		ScrollOffset = ContentHeight
	end 
	if ScrollOffset > 0 then 
		Window.NoteContentTab:Refresh(ScrollOffset)
	end 
	Editor:UpdateFavoriteCDs()
end 

Editor.UpdateFavoriteCDs = function(self)
	if Window then 
		local ScrollOffset = 0
		if Window.CDAnchorFrame then 
			ScrollOffset = Window.CDAnchorFrame.FavoritesList.ScrollOffset
			Window.CDAnchorFrame:Release()
			Window.CDAnchorFrame = nil
		end 
		if Window.CDFlyoutBtn then 
			Window.CDFlyoutBtn:Release()
			Window.CDFlyoutBtn = nil
		end 

		Window.CDAnchorFrame = Widgets:CreateFrame()
		Window.CDAnchorFrame:Size(col3,20)
		Window.CDAnchorFrame:SetPoint("TOPLEFT",Window.NoteContentTab,"TOPRIGHT",Padding,0)


		Window.CDAnchorFrame.RaidCDLB = Widgets:FetchFontString(Window)
		Window.CDAnchorFrame.RaidCDLB:SetText(Loc:Translation("COOLDOWNS"))
		Window.CDAnchorFrame.RaidCDLB:SetWidth(col3)
		Window.CDAnchorFrame.RaidCDLB:SetJustifyH("LEFT")
		Window.CDAnchorFrame.RaidCDLB:SetFontSizeOnly(15)
		Widgets:SetThemedColor(Window.CDAnchorFrame.RaidCDLB,"Highlight")
		Window.CDAnchorFrame.RaidCDLB:SetPoint("TOPLEFT",Window.CDAnchorFrame,"TOPLEFT")

		Window.CDAnchorFrame.CreateCDBtn = Widgets:CreateButton(Window)
		Window.CDAnchorFrame.CreateCDBtn:SetPoint("TOPLEFT",Window.NoteContentTab,"TOPRIGHT",Padding,-20)
		Window.CDAnchorFrame.CreateCDBtn:Size(col3,20)
		Window.CDAnchorFrame.CreateCDBtn:SetText(Loc:Translation("CREATE_NEW"),nil,"Highlight")
		Window.CDAnchorFrame.CreateCDBtn.OnClick = function()
			Editor:NoteCooldownEdit("",function(NewCDLink)
				_ARTG.SV.CooldownEdit("Create",NewCDLink)
			end)
		end

		Window.CDAnchorFrame.LastThreeCDsLB = Widgets:FetchFontString(Window)
		Window.CDAnchorFrame.LastThreeCDsLB:SetText(Loc:Translation("PREVIOUSLY_CREATED"))
		Window.CDAnchorFrame.LastThreeCDsLB:SetWidth(col3)
		Window.CDAnchorFrame.LastThreeCDsLB:SetJustifyH("LEFT")
		Window.CDAnchorFrame.LastThreeCDsLB:SetFontSizeOnly(12)
		Widgets:SetThemedColor(Window.CDAnchorFrame.LastThreeCDsLB,"Highlight")
		Window.CDAnchorFrame.LastThreeCDsLB:SetPoint("TOPLEFT",Window.CDAnchorFrame.CreateCDBtn,"BOTTOMLEFT",0,-Padding)

		--/dump FriendsListFrameScrollFrameButton8.Favorite
		--2923258

		for i = 1,3 do 
			Window.CDAnchorFrame["PreviousCD"..i] = Widgets:CreateFrame(Window)
			if i == 1 then 
				Window.CDAnchorFrame["PreviousCD"..i]:SetPoint("TOPLEFT",Window.CDAnchorFrame.CreateCDBtn,"BOTTOMLEFT",0,-Padding-15)
			else 
				Window.CDAnchorFrame["PreviousCD"..i]:SetPoint("TOPLEFT",Window.CDAnchorFrame["PreviousCD"..(i-1)],"BOTTOMLEFT",0,-Padding)
			end 
			Window.CDAnchorFrame["PreviousCD"..i]:Size(col3,20)
			Window.CDAnchorFrame["PreviousCD"..i]:SetThemedBackdrop()
	
			Window.CDAnchorFrame["PreviousCD"..i].FavoriteBtn = Widgets:CreateFrame(Window.CDAnchorFrame["PreviousCD"..i])
			Window.CDAnchorFrame["PreviousCD"..i].FavoriteBtn:Size(20,20)
			Window.CDAnchorFrame["PreviousCD"..i].FavoriteBtn:SetPoint("TOPRIGHT")

			if AvyrRaidTools_DB.EditorCooldowns.LastCreated[i] then 
				local DisplayString,CD,Name = _ARTG.SV.NoteEntry("CD","Display",AvyrRaidTools_DB.EditorCooldowns.LastCreated[i])
				Window.CDAnchorFrame["PreviousCD"..i]:SetText(DisplayString,nil,"Highlight",nil,nil,"LEFT")
				if _ARTG.SV.CooldownEdit("IsFavorite",AvyrRaidTools_DB.EditorCooldowns.LastCreated[i]) then 
					Window.CDAnchorFrame["PreviousCD"..i].FavoriteBtn:SetIcon("TexturePath",Widgets:GetIcon("StarMask"),"Theme","Highlight")
					Window.CDAnchorFrame["PreviousCD"..i].FavoriteBtn:SetScript("OnMouseDown",function(_,btn)
						_ARTG.SV.CooldownEdit("RemoveFavorite",AvyrRaidTools_DB.EditorCooldowns.LastCreated[i])
					end)
				else 
					Window.CDAnchorFrame["PreviousCD"..i].FavoriteBtn:SetIcon("TexturePath",Widgets:GetIcon("StarOutlineMask"),"Theme","Highlight")
					Window.CDAnchorFrame["PreviousCD"..i].FavoriteBtn:SetScript("OnMouseDown",function(_,btn)
						_ARTG.SV.CooldownEdit("AddFavorite",AvyrRaidTools_DB.EditorCooldowns.LastCreated[i])
					end)
				end 
				Window.CDAnchorFrame["PreviousCD"..i]:SetScript("OnMouseDown",function(_,btn)
					if btn == "LeftButton" then 
						PickupCooldown(AvyrRaidTools_DB.EditorCooldowns.LastCreated[i])
					else 
						Editor:NoteCooldownEdit(AvyrRaidTools_DB.EditorCooldowns.LastCreated[i],function(NewCDLink)
							_ARTG.SV.CooldownEdit("Create",NewCDLink)
						end)
					end
				end)
			end 
		end 

		Window.CDAnchorFrame.FavoritesLB = Widgets:FetchFontString(Window)
		Window.CDAnchorFrame.FavoritesLB:SetText(Loc:Translation("FAVORITES").." ("..getn(AvyrRaidTools_DB.EditorCooldowns.Favorites).."/".._ARTG.SV.CooldownEdit("MaxFavorite")..")")
		Window.CDAnchorFrame.FavoritesLB:SetWidth(col3)
		Window.CDAnchorFrame.FavoritesLB:SetJustifyH("LEFT")
		Window.CDAnchorFrame.FavoritesLB:SetFontSizeOnly(12)
		Widgets:SetThemedColor(Window.CDAnchorFrame.FavoritesLB,"Highlight")
		Window.CDAnchorFrame.FavoritesLB:SetPoint("TOPLEFT",Window.CDAnchorFrame.PreviousCD3,"BOTTOMLEFT",0,-Padding)
		
		Window.CDAnchorFrame.FavoritesList = Widgets:CreateAdancedScrollFrame(Window)
		Window.CDAnchorFrame.FavoritesList:SetPoint("TOPLEFT",Window.CDAnchorFrame.PreviousCD3,"BOTTOMLEFT",0,-Padding-15)
		Window.CDAnchorFrame.FavoritesList:Size(col3,Window:GetHeight() - Window.Header:GetHeight() - Window.BtnBar:GetHeight() - Window.EntryEditBtnBar:GetHeight() - Window.NoteHeader:GetHeight() - 10*Padding - 2*BorderSize - 130)
		Window.CDAnchorFrame.FavoritesList.OnContentWidthChanged = function()
			local i = 1
			while Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i] do 
				Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i]:Size(Window.CDAnchorFrame.FavoritesList.Content:GetWidth())
				i = i + 1
			end 
		end

		local FavListHeight = Padding
		for i,v in ipairs(AvyrRaidTools_DB.EditorCooldowns.Favorites) do 
			Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i] = Widgets:CreateFrame(Window.CDAnchorFrame.FavoritesList.Content)
			Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i]:Size(Window.CDAnchorFrame.FavoritesList.Content:GetWidth() - 2*Padding,20)
			Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i]:SetThemedBackdrop()
			Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i]:SetPoint("TOPLEFT",Padding,-FavListHeight)
			local DisplayString,CD,Name = _ARTG.SV.NoteEntry("CD","Display",v)
			Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i]:SetText(DisplayString,nil,"Highlight",nil,nil,"LEFT")
			Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i]:SetScript("OnMouseDown",function(_,btn)
				PickupCooldown(v)
			end)

			Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i].DeleteBtn = Widgets:CreateButton(Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i])
			Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i].DeleteBtn:SetPoint("RIGHT")
			Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i].DeleteBtn:CloseButtonTexture();
			Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i].DeleteBtn:Size(20,20)
			Window.CDAnchorFrame.FavoritesList.Content["CDFavPickupBtn"..i].DeleteBtn.OnClick = function()
				_ARTG.SV.CooldownEdit("RemoveFavorite",v)
			end

			FavListHeight = FavListHeight + 20 + Padding
		end 
		Window.CDAnchorFrame.FavoritesList.Content:Size(nil,FavListHeight)

		if ScrollOffset > 0 then 
			Window.CDAnchorFrame.FavoritesList:Refresh(ScrollOffset)
		end 
	end 
end 
